#!/usr/bin/env bash
set -e
set -u
set -o pipefail

operation="${1}"; shift

case "${operation}" in
    "deploy_challenge")
        while [ "$#" != 0 ]; do
            domain="${1}"; shift
            token_id="${1}"; shift
            token="${1}"; shift
            statuscode="$(curl -s -k -n -L -o /dev/null -w "%{http_code}" "https://${domain}/.well-known/manage_delObjects?ids:list=acme-challenge")"
            if [[ ! "${statuscode:0:1}" = "2" ]]; then
                statuscode="$(curl -s -n -L -o /dev/null -w "%{http_code}" "http://${domain}/.well-known/manage_delObjects?ids:list=acme-challenge")"
            fi
            statuscode="$(curl -s -k -n -L -o /dev/null -w "%{http_code}" "https://${domain}/.well-known/manage_addProduct/PythonScripts/manage_addPythonScript?id=acme-challenge&file=return%20%27${token}%27")"
            if [[ ! "${statuscode:0:1}" = "2" ]]; then
                statuscode="$(curl -s -n -L -o /dev/null -w "%{http_code}" "http://${domain}/.well-known/manage_addProduct/PythonScripts/manage_addPythonScript?id=acme-challenge&file=return%20%27${token}%27")"
                if [[ ! "${statuscode:0:1}" = "2" ]]; then
                    echo 'Failed'
                    exit 1
                fi
            fi
        done
    ;;
    "clean_challenge")
        while [ "$#" != 0 ]; do
            domain="${1}"; shift
            token_id="${1}"; shift
            token="${1}"; shift
            statuscode="$(curl -s -k -n -L -o /dev/null -w "%{http_code}" "https://${domain}/.well-known/manage_delObjects?ids:list=acme-challenge")"
            if [[ ! "${statuscode:0:1}" = "2" ]]; then
                statuscode="$(curl -s -n -L -o /dev/null -w "%{http_code}" "http://${domain}/.well-known/manage_delObjects?ids:list=acme-challenge")"
                if [[ ! "${statuscode:0:1}" = "2" ]]; then
                    echo 'Failed'
                    exit 1
                fi
            fi
        done
    ;;
esac

exit 0
